/*
          JJMASeries.mqh  
(): MetaTrader\experts\include\
*/
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
//|                                                 3c_JMomentum.mq4 | 
//|                 JMA code: Copyright  2005, Weld, Jurik Research | 
//|                                          http://weld.torguem.net | 
//|                JMomentum: Copyright  2005,     Nikolay Kositsin | 
//|                                   Khabarovsk, violet@mail.kht.ru | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
#property copyright "Nikolay Kositsin" 
#property link    "violet@mail.kht.ru" 
#property indicator_separate_window
#property indicator_buffers 3 
#property indicator_color1 Lime
#property indicator_color2 OrangeRed
#property indicator_color3 Gray
//---- input parameters 
extern int M_Period  = 10; //  Momentum
extern int Length    = 8;  //  JMA  
extern int Phase     =-100;// ,    -100 ... +100,    x JMA   
extern int Shift     = 0;  // c     
extern int CountBars = 500;//   ,     
extern int Drow_style= 0;  //    0 -    ,   -   
extern int Input_Price_Customs = 0;// ,      
//(0-"Close", 1-"Open", 2-"High", 3-"Low", 4-"(High+Low)/2", 5- "(high+low+close)/3", 6-"(high+low+close+close)/4") 
//---- indicator buffers 
double Ind_Buffer1[];
double Ind_Buffer2[];
double Ind_Buffer3[]; 
//---- ADX variabls
double Series,trend,Rezalt;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
//| JMomentum initialization function                                | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
int init() 
{ 
//---- 
SetIndexBuffer(0,Ind_Buffer1);
SetIndexBuffer(1,Ind_Buffer2);
SetIndexBuffer(2,Ind_Buffer3);
//----
SetIndexEmptyValue(0,0.0); 
SetIndexEmptyValue(1,0.0); 
SetIndexEmptyValue(2,0.0);
//----
if (Drow_style==0)
{
 SetIndexStyle(0,DRAW_ARROW);
 SetIndexStyle(1,DRAW_ARROW);
 SetIndexStyle(2,DRAW_ARROW);
 //----
 SetIndexArrow(0,159);
 SetIndexArrow(1,159);
 SetIndexArrow(2,159);
}
else 
{
 SetIndexStyle(0,DRAW_HISTOGRAM);
 SetIndexStyle(1,DRAW_HISTOGRAM);
 SetIndexStyle(2,DRAW_HISTOGRAM);
}
//----
SetIndexShift(0, Shift); 
SetIndexShift(1, Shift); 
SetIndexShift(2, Shift); 
//---- 
SetIndexDrawBegin(0,Bars-CountBars-1); 
SetIndexDrawBegin(1,Bars-CountBars-1); 
SetIndexDrawBegin(2,Bars-CountBars-1);
//---- 
SetIndexLabel (0, "JMomentum_Up"); 
SetIndexLabel (1, "JMomentum_Down"); 
SetIndexLabel (2, "JMomentum_St"); 
//----
IndicatorShortName ("JMomentum"); 
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//+======================================================================================================================================+ 
if(Phase<-100) {Alert(" Phase    -100  +100" + "    " +Phase+    "   -100");}//|
if(Phase> 100) {Alert(" Phase    -100  +100" + "    " +Phase+    "    100");}//|
if(M_Period< 1){Alert(" M_Period     1"   + "    " +M_Period+ "    1");}////|
if(Length< 1)  {Alert(" Length     1"     + "    " +Length+   "    1");}////|
//+======================================================================================================================================+ 
if(M_Period< 1)M_Period=1; 
if(Length< 1)Length=1;
//---- initialization done
return(0); 
} 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
//| JMomentum iteration function                                     | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
int start() 
{ 
//----+    
int counted_bars = IndicatorCounted(); 
//----+    
if (counted_bars<0) return (-1);
//----+
int limit=Bars-counted_bars-1;
//----+       JJMASeries, JMAnumberJ=1(   ) 
if (limit==Bars-1){int reset=-1;int set=JJMASeries(1,0,0,0,0,0,0,0,reset);if((reset!=0)||(set!=0))return(-1);}
//----+  
 for(int bar=limit;bar>=0;bar--)
 {
 switch(Input_Price_Customs)
    {
    //----+  ,       +--+
     case 0:  Series=iMomentum(NULL,0,M_Period,PRICE_CLOSE,   bar);break;
     case 1:  Series=iMomentum(NULL,0,M_Period,PRICE_OPEN,    bar);break;
     case 2:  Series=iMomentum(NULL,0,M_Period,PRICE_HIGH,    bar);break;
     case 3:  Series=iMomentum(NULL,0,M_Period,PRICE_LOW,     bar);break;
     case 4:  Series=iMomentum(NULL,0,M_Period,PRICE_MEDIAN,  bar);break;
     case 5:  Series=iMomentum(NULL,0,M_Period,PRICE_TYPICAL, bar);break;
     case 6:  Series=iMomentum(NULL,0,M_Period,PRICE_WEIGHTED,bar);break;
     default: Series=iMomentum(NULL,0,M_Period,PRICE_CLOSE,   bar);
    //----+-----------------------------------------------------------------------+   
    }
  Series=(Series-100)*100;
  
  //----+    JJMASeries   0,  JMAPhase  JMALength      (JMAdin=0)
  reset=1;Rezalt=JJMASeries(0,0,Bars-1,limit,Phase,Length,Series,bar,reset);if(reset!=0)return(-1); 
  
  //---- +SSSSSSSSSSSSSSSS <<< Three colore code >>> SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
  trend=Rezalt-Ind_Buffer1[bar+1]-Ind_Buffer2[bar+1]-Ind_Buffer3[bar+1];     
  if(trend>0.0)     {Ind_Buffer1[bar]=Rezalt; Ind_Buffer2[bar]=0.0;    Ind_Buffer3[bar]=0.0;}
  else{if(trend<0.0){Ind_Buffer1[bar]=0.0;    Ind_Buffer2[bar]=Rezalt; Ind_Buffer3[bar]=0.0;}
  else              {Ind_Buffer1[bar]=0.0;    Ind_Buffer2[bar]=0.0;    Ind_Buffer3[bar]=Rezalt;}}    
  //---- +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
 }
//----+
return(0);  
}
//----+   JJMASeries ( JJMASeries.mqh     (): MetaTrader\experts\include)
#include <JJMASeries.mqh> 