/*
          JJMASeries.mqh  
(): MetaTrader\experts\include\
*/
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
//|                                                    JMomentum.mq4 | 
//|                 JMA code: Copyright  2005, Weld, Jurik Research | 
//|                                          http://weld.torguem.net | 
//|                JMomentum: Copyright  2005,     Nikolay Kositsin | 
//|                                   Khabarovsk, violet@mail.kht.ru | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
#property copyright "Weld" 
#property link "http://weld.torguem.net" 
#property indicator_separate_window
#property indicator_color1 Red 
//---- input parameters 
extern int M_Period  = 10; //  Momentum
extern int Length    = 8;  //  JMA  
extern int Phase     =-100;// ,    -100 ... +100,    x JMA   
extern int Shift     = 0;  // c     
extern int CountBars = 500;//   ,     
extern int Input_Price_Customs = 0;// ,      
//(0-"Close", 1-"Open", 2-"High", 3-"Low", 4-"(High+Low)/2", 5- "(high+low+close)/3", 6-"(high+low+close+close)/4") 
//---- indicator buffers 
double Ind_Buffer[ ]; 
//---- ADX variabls
double Series;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
//| JMomentum initialization function                                | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
int init() 
{ 
SetIndexStyle(0, DRAW_LINE); 
SetIndexShift(0, Shift); 
//---- 1 indicator buffer[n]s mapping 
SetIndexBuffer    (0, Ind_Buffer);
SetIndexDrawBegin (0,Bars-CountBars-1); 
SetIndexEmptyValue(0,0.0); 
//---- 
SetIndexLabel   (0, "JMomentum"); 
IndicatorShortName ("JMomentum"); 
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//+======================================================================================================================================+ 
if(Phase<-100) {Alert(" Phase    -100  +100" + "    " +Phase+    "   -100");}//|
if(Phase> 100) {Alert(" Phase    -100  +100" + "    " +Phase+    "    100");}//|
if(M_Period< 1){Alert(" M_Period     1"   + "    " +M_Period+ "    1");}////|
if(Length< 1)  {Alert(" Length     1"     + "    " +Length+   "    1");}////|
//+======================================================================================================================================+ 
//---- initialization done
return(0); 
} 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
//| JMomentum iteration function                                     | 
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
int start() 
{ 
//----+    
int counted_bars = IndicatorCounted(); 
//----+    
if (counted_bars<0) return (-1);
//----+ 
int limit=Bars-counted_bars-1;
//----+       JJMASeries, JMAnumberJ=1(   ) 
if (limit==Bars-1){int reset=-1;int set=JJMASeries(1,0,0,0,0,0,0,0,reset);if((reset!=0)||(set!=0))return(-1);}
//----+  
 for(int k=limit;k>=0;k--)
 {
 switch(Input_Price_Customs)
    {
    //----+  ,       +--+
     case 0:  Series=iMomentum(NULL,0,M_Period,PRICE_CLOSE,   k);break;
     case 1:  Series=iMomentum(NULL,0,M_Period,PRICE_OPEN,    k);break;
     case 2:  Series=iMomentum(NULL,0,M_Period,PRICE_HIGH,    k);break;
     case 3:  Series=iMomentum(NULL,0,M_Period,PRICE_LOW,     k);break;
     case 4:  Series=iMomentum(NULL,0,M_Period,PRICE_MEDIAN,  k);break;
     case 5:  Series=iMomentum(NULL,0,M_Period,PRICE_TYPICAL, k);break;
     case 6:  Series=iMomentum(NULL,0,M_Period,PRICE_WEIGHTED,k);break;
     default: Series=iMomentum(NULL,0,M_Period,PRICE_CLOSE,   k);
    //----+-----------------------------------------------------------------------+   
    }
  Series=(Series-100)*100;
  //----+    JJMASeries   0,  JMAPhase  JMALength      (JMAdin=0)
  reset=1;Ind_Buffer[k]=JJMASeries(0,0,Bars-1,limit,Phase,Length,Series,k,reset);if(reset!=0)return(-1); 
 }
//----+
return(0);  
}
//----+   JJMASeries ( JJMASeries.mqh     (): MetaTrader\experts\include)
#include <JJMASeries.mqh> 